library IEEE;
use IEEE.STD_LOGIC_1164.all;
entity pulseGen_tb is
	--  Port ( );
end pulseGen_tb;

architecture Behavioral of pulseGen_tb is
	-- Konstante  
	constant CLK_PERIOD : time := 10 ns;

	-- Komponenta za test
	component pulseGen is
		port (
			clk    : in  std_logic;
			rst    : in  std_logic;
			kclk_s : in  std_logic;
			pulse  : out std_logic);
	end component;

	-- Vhodni signali, ki UUT povezujejo z generatorjem draljajev
	signal clk, rst : std_logic := '0';
	signal kclk_s   : std_logic := '1'; -- v stanju mirovanja mora biti visok

	-- Izhodni signali, ki UUT povezujejo z osciloskopom
	signal pulse    : std_logic;

begin
	-- Unit under test
	UUT : pulseGen
	port map(
		clk    => clk,
		kclk_s => kclk_s,
		rst    => rst,
		pulse  => pulse
	);

	-- Generator draljajev 
	-- Ura 
	CLK_STIMULUS : process
	begin
		clk <= not clk;
		wait for CLK_PERIOD/2;
	end process;

	-- Ostali signali 
	OTH_STIMULI : process
	begin
		-- Reset
		rst    <= '1';
		kclk_s <= '1';
		wait for CLK_PERIOD * 3;
		rst <= '0';

		for i in 0 to 2 loop
			-- Mirovanje 
			kclk_s <= '1';
			wait for CLK_PERIOD * 3;

			-- Ura gre v nizko stanje 
			kclk_s <= '0';
			wait for CLK_PERIOD * 3;
		end loop;

		-- Ponastavitev ure 
		kclk_s <= '1';
		wait; -- akaj neskonno dolgo      
	end process;
end Behavioral;